﻿using System;

using System.Collections.Generic;
using System.Text;

namespace Fluid.Controls
{
    /// <summary>
    /// Specifies the shape of a button.
    /// </summary>
    public enum ButtonShape
    {
        /// <summary>
        /// The button is rounded at all corners.
        /// </summary>
        Rounded,

        /// <summary>
        /// The button appears to be flat.
        /// </summary>
        Flat,

        /// <summary>
        /// The button appears as a rectangle.
        /// </summary>
        Rectangle,

        /// <summary>
        /// The button has a back pointer shape.
        /// </summary>
        Back,

        /// <summary>
        /// The button has a next pointer shape.
        /// </summary>
        Next,

        /// <summary>
        /// The button appears a an ellipsis.
        /// </summary>
        Ellipse
    }

}
