﻿using System;

using System.Collections.Generic;
using System.Text;

namespace PasswordSafe.Xml
{
    public class FieldInfo
    {

        public FieldInfo(string name, string title)
            : base()
        {
            Name = name;
            Title = title;
        }

        public FieldInfo(string name, string title, FieldType type)
            : base()
        {
            Name = name;
            Title = title;
            Type = type;
        }

        public FieldInfo()
            : base()
        {
        }

        public string Name { get; set; }
        public string Title { get; set; }

        public FieldType Type { get; set; }

    }

    public class Separator : FieldInfo
    {
        public Separator()
            : base()
        {
            Type = FieldType.Separator;
        }
    }

    public enum FieldType
    {
        Password,
        EMail,
        User,
        String,
        Int,
        Date,
        Separator
    }
}
